Loading...
Searching...
No Matches
DataProvider::QoreSoftBinaryNoNullDataType Class Reference

describes a data type based on softbinary with validation for parsing strings More...

`#include <QoreSoftBinaryNoNullDataType.qc.dox.h>`

Inheritance diagram for DataProvider::QoreSoftBinaryNoNullDataType:
[legend]

## Public Member Functions

| constructor (*hash< auto > options, *hash< auto > tags)
| creates the object
Public Member Functions inherited from DataProvider::QoreSoftBinaryDataType
| constructor (*hash< auto > options, *hash< auto > tags)
| creates the object
Public Member Functions inherited from DataProvider::QoreBinaryDataTypeBase
auto | acceptsValue (auto value)
| returns the value if the value can be assigned to the type
AbstractDataProviderType | getSoftType ()
| returns a "soft" type equivalent to the current type
Public Member Functions inherited from DataProvider::QoreDataType
auto | acceptsValue (auto value)
| returns the value if the value can be assigned to the type
| constructor (Type type, *hash< auto > options, *hash< auto > tags, auto default_value, *hash< NameDescInfo > attr, *string path)
| creates the type
hash< string, bool > | getAcceptTypeHash (*bool simple)
| returns a hash of base types accepted by this type; keys are type names
auto | getDefaultValue ()
string | getDesc ()
| Returns the description.
*hash< string, bool > | getDirectTypeHash ()
| returns a hash of native base type code where no translations are performed; keys are type codes, not names
string | getDisplayName ()
| Returns the type's display name.
*AbstractDataProviderType | getElementType ()
| returns the subtype (for lists or hashes) if there is only one
*hash< string, AbstractDataField > | getFields ()
| returns the fields of the data structure; if any
hash< DataTypeInfo > | getInfo (*bool simple)
| returns a description of the type as a hash
AbstractDataProviderType | getMandatoryType ()
| Returns a mandatory (i.e. not "or nothing") type equivalent to the current type.
string | getName ()
| returns the type name
AbstractDataProviderType | getOrNothingType ()
| returns an "or nothing" type equivalent to the current type
hash< string, bool > | getReturnTypeHash (*bool simple)
| returns a hash of base types returned by this type; keys are type names
string | getShortDescription ()
| Returns the type's short description.
AbstractDataProviderType | getSoftType ()
| returns a "soft" type equivalent to the current type
*hash< string, hash< DataProviderTypeOptionInfo > > | getSupportedOptions ()
| returns supported options
*Type | getValueType ()
| returns the base type for the type, if any
bool | hasDefaultValue ()
| ! Returns True if this type has a default value
Public Member Functions inherited from DataProvider::AbstractDataProviderType
abstract auto | acceptsValue (auto value)
| Returns the value if the value can be assigned to the type.
| clearPath ()
| Clears the type path for the type.
| constructor ()
| creates the type
| constructor (*hash< auto > options, hash< auto > tags, *string path)
| creates the type and sets options
| constructor (hash< auto > options, *hash< auto > tags, *string path)
| creates the type and sets options
| constructor (string path)
| creates the type
abstract hash< string, bool > | getAcceptTypeHash (*bool simple)
| Returns a hash of types accepted by this type; keys are type names.
int | getBaseTypeCode ()
| Returns the base type code for the type.
string | getBaseTypeName ()
| Returns the base type name for the type; must be a standard Qore base type name.
auto | getDefaultValue ()
string | getDesc ()
| Returns the description.
*hash< string, bool > | getDirectTypeHash ()
| Returns a hash of native base type code keys where no translations are performed; keys are type codes, not names.
string | getDisplayName ()
| Returns the type's display name.
abstract *AbstractDataProviderType | getElementType ()
| Returns the subtype (for lists or hashes) if there is only one.
auto | getExampleValue (*hash< string, bool > emap, *string fname)
| Returns any example value for type, if any.
*AbstractDataField | getField (string field_name)
| Returns the given field, if present, or nothing if not.
*hash< string, hash< DataFieldInfo > > | getFieldInfo ()
| Returns information on fields supported.
abstract *hash< string, AbstractDataField > | getFields ()
| Returns the fields of the data structure; if any.
*AbstractDataProviderType | getFieldType (string field_name)
| get the given field type if it exists, otherwise return nothing
hash< DataTypeInfo > | getInfo (*bool simple)
| Returns a description of the type as a hash.
hash< DataTypeInfo > | getInputInfo (*bool simple)
| Returns a description of the type as an input type.
AbstractDataProviderType | getMandatoryType ()
| Returns a mandatory (i.e. not "or nothing") type equivalent to the current type.
abstract string | getName ()
| Returns the type name.
*hash< auto > | getOptions ()
| Returns options set on the type.
auto | getOptionValue (string opt)
| Returns the value of the given option.
AbstractDataProviderType | getOrNothingType ()
| Returns an "or nothing" type equivalent to the current type.
*string | getPath ()
| Returns the type path in the type cache, if any.
*hash< auto > | getPublicOptions ()
| Returns options with the publish flag set on the type.
abstract hash< string, bool > | getReturnTypeHash (*bool simple)
| Returns a hash of types returned by this type; keys are type names.
string | getShortDescription ()
| Returns the type's short description.
AbstractDataProviderType | getSoftType ()
| Returns a "soft" type equivalent to the current type.
*hash< string, hash< DataProviderTypeOptionInfo > > | getSupportedOptions ()
| Returns supported options.
auto | getTag (string tag)
| Returns the value of the given tag.
*hash< auto > | getTags ()
| Returns tags set on the type.
abstract *Type | getValueType ()
| Returns the base type for the type, if any.
bool | hasDefaultValue ()
| ! Returns True if this type has a default value
bool | hasType ()
| Returns True if the type is not a wildcard type.
bool | isAssignableFrom (AbstractDataProviderType t)
| Returns True if this type can be assigned from values of the argument type.
bool | isAssignableFrom (Type t)
| Returns True if this type can be assigned from values of the argument type.
bool | isList ()
| Returns True if this type is a list.
bool | isMandatory ()
| Returns True if the type must have a value.
bool | isOrNothingType ()
| Returns True if the type also accepts nothing.
| setDynamicTag ()
| Sets the dynamic tag on the type.
| setOption (string opt, auto value)
| sets the given option on the type
| setOptions (hash< auto > options)
| sets options on the type
| setPath (string path)
| Sets the type path for the type.

## Additional Inherited Members

Static Public Member Functions inherited from DataProvider::AbstractDataProviderType
static AbstractDataProviderType | get (hash< DataTypeInfo > info)
| Returns an appropriate object for the given type description.
static AbstractDataProviderType | get (string typename, *hash< auto > options)
| Returns an appropriate object for the given type.
static AbstractDataProviderType | get (Type type, *hash< auto > options, *hash< auto > tags, auto default_value, *hash< NameDescInfo > attr)
| Returns an appropriate object for the given type.
Public Attributes inherited from DataProvider::AbstractDataProviderType
const | DefaultDesc = "no description available"
| Default description.
Static Public Attributes inherited from DataProvider::AbstractDataProviderType
Protected Member Functions inherited from DataProvider::QoreBinaryDataTypeBase
| constructor (Type type, *hash< auto > options, *hash< auto > tags)
| creates the object
Protected Member Functions inherited from DataProvider::AbstractDataProviderType
| setOptionIntern (string opt, auto value)
| sets the given option without any validation of the option
Protected Attributes inherited from DataProvider::QoreDataType
*hash< string, bool > | accept_type_hash
| hash of base types accepted by this type; keys are type names
*hash< string, bool > | accept_type_hash_simple
| hash of base types accepted by this type; keys are simple type names
hash< string, bool > | base_type_hash
| hash of base types where no translations are performed; keys are type codes, not names
hash< string, bool > | blacklist_type_hash
| hash of type codes accepted by the base type but not accepted by this type: code -> True
auto | default_value
| Default value for type.
string | desc
| The long description for the type in markdown.
string | display_name
| The display name for the type.
string | name
| The name of the type; if not set then the name of "type" is used instead.
bool | or_nothing_type
| flag for "or nothing" types
*hash< string, bool > | return_type_hash
| hash of base types returned by this type; keys are type names
*hash< string, bool > | return_type_hash_simple
| hash of base types returned by this type; keys are simple type names
string | short_desc
| The short plain-text description for the type.
bool | soft_type
| flag for soft types
const | SoftTypeMap = ...
| map from normal types to soft types
const | SupportedOptions = ...
| supported options
Type | type
| the Qore type
Protected Attributes inherited from DataProvider::AbstractDataProviderType
hash< auto > | options
| type options
*string | path
| The type path, if any.
*hash< auto > | tags
| type tags

## Detailed Description

describes a data type based on softbinary with validation for parsing strings